#include <Wire.h>

#define IICCMD_NOP  0
#define IICCMD_DIR  1
#define IICCMD_SPD  2
#define IICCMD_FN   3
#define IICCMD_ACC  4
#define IICCMD_CONS 5
#define IICCMD_OPS  6
#define IICCMD_CVW  7
#define IICCMD_CVR  8
#define IICCMD_S88  9

class IICTRANS {
public:
	byte Cmd;
	word Addr;
	byte Dir;
	byte Dat;
	byte Stat;
	
	IICTRANS();
	
	void IICstart(byte inMode);
	byte IICrecvByte();
	byte getIICData(word AccOffset);
	void IICsend(word inAddr, byte inCmd, int inDat, byte inStat=0);
};

extern IICTRANS IICtrans;
