
var gROBOT_StateLast = 0;
var gROBOT_State = 0;
var gROBOT_Line = 0;
var gROBOT_LineMax = 0;
var gROBOT_Script = "END;";
var gROBOT_GenCode;
var gROBOT_WaitCount = 0;
var gROBOT_WaitState = 0;
var gROBOT_WaitCountMax = 0;
var gROBOT_LocAddr = 0;

//Speed
var gROBOT_SpeedTargetEnd = 0;
var gROBOT_SpeedTargetStart = 0;
var gROBOT_SpeedLast = 0;

//ATC bell
var audioATC;
var audioSTART;

//Document Ready
$(function () {

    // �I�[�f�B�I
    audioATC = new Audio();
    audioSTART = new Audio();
    
    //Original, Yaasan, Keio, 20190918
    audioSTART.src = "/SD_WLAN/sound/startbeep.mp3";

    audioATC.src = "/SD_WLAN/block/locmedia/atc_bell.mp3";

});    

function ROBOT_Cancel()
{
    if( gROBOT_State == 1)
    {
        //Deactivate automatic control
        gROBOT_State = 0;

        //Clear robot script
        gROBOT_WaitCount = 0;

        //ATC meter Off
        gATCSpeed = -1;

        //Background image drawing
        onDrawMeter(40);

        toastr.info('ROBOT OFF.');
        $('#btnRobot').prop('checked', false).change();
    }
}

function ROBOT_CurrentState()
{
    return gROBOT_State;
}

function ROBOT_click()
{
    if( gROBOT_State == 0)
    {

        //Activate automatic control

        gROBOT_LocAddr = parseInt(dblLocArray[modeLocIndex]);

        //Generate robot script
        ROBOT_GenerateScript(1);

        //State changes to RUN
        gROBOT_State = 1;

        //Background image drawing
        onDrawMeter(40);

        toastr.info('ROBOT ON.');
    }
    else
    {
        //Deactivate automatic control
        ROBOT_Cancel();
    }


}

function ROBOT_main()
{

    var aReDraw = 0;

    switch(gROBOT_State)
    {
        case 0:
            //Not working robot script
        break;

        case 1:
            //Interpret robot script

            if( gROBOT_WaitCount == 0)
            {
                ROBOT_Interpret();

                gROBOT_Line = gROBOT_Line + 1;

                if( gROBOT_Line >= gROBOT_LineMax)
                {
                    //Generate robot script
                    ROBOT_GenerateScript(0);
                }


            }
            else if( gROBOT_WaitCount > 0)
            {
                //Wait
                switch(gROBOT_WaitState)
                {
                case 0:
                    //Normal wait, Nothing to do
                    break;
                case 1:
                    //Normal wait, Nothing to do
                    
                    var aSpeedTemp = 0;
                     
                    if( gROBOT_SpeedTargetStart <= gROBOT_SpeedTargetEnd)
                    {
                        aSpeedTemp = (gROBOT_SpeedTargetEnd - gROBOT_SpeedTargetStart) * (gROBOT_WaitCountMax - gROBOT_WaitCount) / gROBOT_WaitCountMax;
                        //Acc
                        aSpeedTemp = Math.round(gROBOT_SpeedTargetStart + aSpeedTemp);
                    }
                    else
                    {
                        aSpeedTemp = (gROBOT_SpeedTargetStart - gROBOT_SpeedTargetEnd) * gROBOT_WaitCount / gROBOT_WaitCountMax;
                        //Dec
                        aSpeedTemp = Math.round(gROBOT_SpeedTargetEnd + aSpeedTemp);
                    }

                    if( gROBOT_WaitCount <= 1)
                    {
                        onChangeSpeed(gROBOT_SpeedTargetEnd);
                        //CommandLocSpeed(gROBOT_LocAddr, gROBOT_SpeedTargetEnd);

                        gROBOT_SpeedLast = gROBOT_SpeedTargetEnd;
                    }
                    else
                    {
                        //console.log(aSpeedTemp);
                        onChangeSpeed(aSpeedTemp);
                        //CommandLocSpeed(gROBOT_LocAddr, aSpeedTemp);
                    }
                    break;
    

                }

                gROBOT_WaitCount--;
            }
            else
            {
                console.log("WaitCount lost");
                gROBOT_State = 0;
            }
            
            //ATC Stop and declaration process
            if( gATCStopTimer > 0)
            {
                gATCStopTimer = gATCStopTimer - 1;
                gATCSpeed = gATCSpeedStop + gATCStopTimer * (gATCSpeedLast - gATCSpeedStop) / gATCStopTimerMax;

                if( gATCStopTimer == 0)
                {
                    gATCSpeed = gATCSpeedStop;
                    gATCSpeedStop = 0;

                }

                aReDraw = 1;

            }

            break;
    }

    //Redraw Meter
    if( aReDraw == 1)
    {
        //Draw
        onDrawMeter(40);    
    }


}

//Generate Robot script
function ROBOT_GenerateScript(inGenerationType)
{

    //Pick up current speed
    var aCurrentSpeed = GetSlotSpeed(modeLocIndex);

    //Robot: XXXX
    gROBOT_Script = ROBOT_Gen_Subrub(aCurrentSpeed);
    //gROBOT_Script = ROBOT_Gen_Express(aCurrentSpeed);

    //Split Script 
    gROBOT_GenCode = gROBOT_Script.split(";");
    gROBOT_LineMax = gROBOT_GenCode.length;
    gROBOT_WaitCount = 0;
    gROBOT_Line = 0;

}


function ROBOT_Gen_Subrub(inCurSpeed)
{
    var aScript = "ATC,682;WAIT,2;BEEP;";

    if( inCurSpeed > 0 )
    {
        gROBOT_SpeedLast = inCurSpeed;
        aScript = aScript + "SPEED,0,650,10;";

    }
    else
    {
        gROBOT_SpeedLast = 0;
        aScript = aScript + "SPEED,0,650,30;";
    }

    aScript = aScript + "ATC,811;";
    aScript = aScript + "SPEED,0,768,10;";

    aScript = aScript + "SPEED,0,700,60;";
    aScript = aScript + "SPEED,0,800,10;";
    aScript = aScript + "SPEED,0,790,10;";

    aScript = aScript + "ATCSTOP,640,6;";
    aScript = aScript + "SPEED,0,600,5;";
    aScript = aScript + "WAIT,1;";
    aScript = aScript + "MESSAGE,next station is...;";
    aScript = aScript + "ATCSTOP,0,38;";
    aScript = aScript + "SPEED,0,0,35;";
    aScript = aScript + "MESSAGE,Arrived a station;";
    aScript = aScript + "WAIT,3;";
    aScript = aScript + "ATC,682;";
    aScript = aScript + "WAIT,9;";
    aScript = aScript + "MESSAGE,Only have 20 sec.;";
    aScript = aScript + "WAIT,10;";
    aScript = aScript + "MESSAGE,Only have 10 sec.;";
    aScript = aScript + "WAIT,10;";
    aScript = aScript + "MESSAGE,Here we go!;";   

    return aScript;
}

function ROBOT_Gen_Express(inCurSpeed)
{
    var aScript = "ATC,725;WAIT,2;BEEP;";

    if( inCurSpeed > 0 )
    {
        gROBOT_SpeedLast = inCurSpeed;
        aScript = aScript + "SPEED,0,700,10;";

    }
    else
    {
        gROBOT_SpeedLast = 0;
        aScript = aScript + "SPEED,0,700,30;";
    }
    aScript = aScript + "SPEED,0,610,60;";
    aScript = aScript + "SPEED,0,710,10;";

    aScript = aScript + "SPEED,0,660,30;";
    aScript = aScript + "ATC,854;";
    aScript = aScript + "SPEED,0,840,30;";
    aScript = aScript + "SPEED,0,740,60;";
    aScript = aScript + "SPEED,0,840,10;";
    aScript = aScript + "SPEED,0,790,30;";
    aScript = aScript + "ATCSTOP,768,13;";
    aScript = aScript + "SPEED,0,750,10;";
    aScript = aScript + "SPEED,0,700,30;";
    aScript = aScript + "SPEED,0,750,10;";
    aScript = aScript + "SPEED,0,740,10;";
    aScript = aScript + "ATCSTOP,726,13;";
    aScript = aScript + "SPEED,0,700,10;";
    aScript = aScript + "SPEED,0,650,50;";
    aScript = aScript + "ATC,768;";
    aScript = aScript + "SPEED,0,750,10;";
    aScript = aScript + "SPEED,0,660,30;";
    aScript = aScript + "ATC,854;";
    aScript = aScript + "SPEED,0,840,30;";
    aScript = aScript + "SPEED,0,740,60;";
    aScript = aScript + "SPEED,0,840,10;";
    aScript = aScript + "SPEED,0,790,30;";
    aScript = aScript + "ATCSTOP,768,13;";
    aScript = aScript + "SPEED,0,750,10;";
    aScript = aScript + "SPEED,0,740,10;";
    aScript = aScript + "ATCSTOP,725,15;";
    aScript = aScript + "SPEED,0,700,10;";
    aScript = aScript + "WAIT,1;";
    aScript = aScript + "MESSAGE,next station is...;";
    aScript = aScript + "ATCSTOP,0,33;";
    aScript = aScript + "SPEED,0,0,30;";
    aScript = aScript + "MESSAGE,Arrived a station;";
    aScript = aScript + "WAIT,3;";
    aScript = aScript + "ATC,682;";
    aScript = aScript + "WAIT,9;";
    aScript = aScript + "MESSAGE,Only have 20 sec.;";
    aScript = aScript + "WAIT,10;";
    aScript = aScript + "MESSAGE,Only have 10 sec.;";
    aScript = aScript + "WAIT,10;";
    aScript = aScript + "MESSAGE,Here we go!;";   

    return aScript;
}



function ROBOT_PlaySound() {
    audioATC.play();
}

function ROBOT_PlaySoundBeep() {
    audioSTART.play();
}

//Interpret Robot Script
function ROBOT_Interpret()
{
    if( gROBOT_Line < gROBOT_LineMax)
    {
        var aFunc = gROBOT_GenCode[gROBOT_Line].split(",");

        var aCmd = aFunc[0];


        switch(aCmd)
        {
            case "END":
                //Generate robot script
                ROBOT_GenerateScript(0);
                break;

            case "SPEED":
                gROBOT_SpeedTargetEnd = Number(aFunc[2]);
                gROBOT_SpeedTargetStart = Number(gROBOT_SpeedLast);
                gROBOT_WaitCountMax = aFunc[3] * 2;// 1d=0.5sec
                gROBOT_WaitCount = gROBOT_WaitCountMax;
                gROBOT_WaitState = 1;
                //TEST, will implement HLR.
                //CommandLocSpeed(gROBOT_LocAddr, gROBOT_SpeedTargetEnd);
                break;

            case "FNC":
                CommandLocFunction(gROBOT_LocAddr, aFunc[2], aFunc[3]);
                gROBOT_WaitCount = 1;//500ms
                gROBOT_WaitState = 0;
                break;

            case "BEEP":
                ROBOT_PlaySoundBeep();
                break;
            
            case "ACC":
                 //   ChangeAcc(aFunc[1]);
                gROBOT_WaitCount = 1;//500ms
                gROBOT_WaitState = 0;
                break;
                
            case "WAIT":
                gROBOT_WaitCount = aFunc[1] * 2;
                gROBOT_WaitState = 0;
                break;
                    
            case "JMP":
                break;

            case "LABEL":
                    break;

            case "WAITIF":
                    break;
                    
            case "GOTOIF":
                    break;

            case "ATCSTOP":

                if( gATCSpeed > Number(aFunc[1]) )
                {
                    gATCSpeedLast = gATCSpeed;
                    gATCSpeedStop = Math.trunc(Number(aFunc[1]) / 42.66666666666) * 42.66666666666;
                    gATCStopTimer = Number(aFunc[2]) * 2;
                    gATCStopTimerMax = gATCStopTimer;

                    if( gATCSpeedStop == 0)
                    {
                        //Stop Beep

                    }
                    else
                    {
                        //ATC bell
                        ROBOT_PlaySound();
                    }

                    //Background image drawing
                    onDrawMeter(40);
                }
                else
                {
                    console.log("ATCSTOP error.");
                }

                break;

            case "ATC":
                gATCSpeedStop = 0; 
                gATCStopTimer = 0;
                
                if( Number(aFunc[1]) < 0 )
                {
                    gATCSpeed = -1;
                }
                else if( Number(aFunc[1]) == gATCSpeed)
                {
                    //Nothing to do
                }
                else
                {
                    gATCSpeed = Math.ceil(Number(aFunc[1]) / 42.66666666) * 42.66666666;
                    ROBOT_PlaySound();
                }

                //Background image drawing
                onDrawMeter(40);

                break;
                    
            case "DIRECTION":
                onClickFwd(aFunc[2]);
                //CommandLocDirection(gROBOT_LocAddr, aFunc[2]);
                gROBOT_WaitCount = 1;//500ms
                gROBOT_WaitState = 0;
                break;                   
            
            case "MESSAGE":
                toastr.success(aFunc[1]);
                break;

                    
        }


        
    }



}